﻿using Kivii.Funq;
using Kivii.Linq;
using Kivii.Third.Scjgj.Entities;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Third.Scjgj
{
    internal static class Extensions
    {
        internal static Report ConvertTo(this PlanDetail item)
        {
            var rtns = new Report();
            rtns.Metadata = new Dictionary<string, string>();
            switch (item.CHECK_TYPE)
            {
                case "1":
                    rtns.ConvertGetSUB(item);
                    rtns.ConvertGetOther(item);
                    rtns.ConvertGetCary(item);
                    rtns.ConvertGetPro(item);
                    rtns.ConvertGetGoods(item);
                    rtns.ConvertGetSampling(item);
                    rtns.ConvertGetRemarks(item);
                    break;
                case "2":
                    rtns.ConvertGetSUB(item);
                    rtns.ConvertGetOther(item);
                    rtns.ConvertGetCary(item);
                    rtns.ConvertGetPro(item);
                    rtns.ConvertGetGoods(item);
                    rtns.ConvertGetSampling(item);
                    rtns.ConvertGetRemarks(item);
                    break;
                case "3":
                    rtns.ConvertGetSUB(item);
                    rtns.ConvertGetOther(item);
                    rtns.ConvertGetEc(item);
                    rtns.ConvertGetPro(item);
                    rtns.ConvertGetGoods(item);
                    rtns.ConvertGetSampling(item);
                    rtns.ConvertGetRemarks(item);
                    break;
                case "4":
                    rtns.ConvertGetSUB(item);
                    rtns.ConvertGetOther(item);
                    rtns.ConvertGetCary(item);
                    rtns.ConvertGetPro(item);
                    rtns.ConvertGetGoods(item);
                    rtns.ConvertGetSampling(item);
                    rtns.ConvertGetRemarks(item);
                    break;
                default:
                    break;
            }
            return rtns;
        }
        /// <summary>
        /// 此方法是将原始的PlanDetail数据从其他子表中将数据丰富完善
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail DataFilling(this PlanDetail item, IDbConnection conn = null)
        {
            PlanDetail rtns = new PlanDetail();
            bool connDispose = false;
            if (conn == null)
            {
                connDispose = true;
                conn = KiviiContext.GetOpenedDbConnection<Plan>();
            }
            item.Plan = GetPlan(conn, item.PLAN_CODE);
            item.Plan.TaskSource = GetTaskSource(conn, item.Plan.TASK_SOURCE);
            if (item.Plan != null)
            {
                switch (item.Plan.CHECK_KIND_PRO)
                {
                    case "1":
                        item.Plan.CHECK_KIND_PRO = "省级监督抽查";
                        break;
                    case "2":
                        item.Plan.CHECK_KIND_PRO = "产品质量风险监测";
                        break;
                    case "3":
                        item.Plan.CHECK_KIND_PRO = "省级联动监督抽查";
                        break;
                    case "4":
                        item.Plan.CHECK_KIND_PRO = "省级专项监督抽查";
                        break;
                    case "5":
                        item.Plan.CHECK_KIND_PRO = "国家联动监督抽查";
                        break;
                    case "6":
                        item.Plan.CHECK_KIND_PRO = "省级监督抽查（产品质量风险监测）";
                        break;
                    case "7":
                        item.Plan.CHECK_KIND_PRO = "联动监督抽查和其他";
                        break;
                    case "08":
                        item.Plan.CHECK_KIND_PRO = "01:定期监督抽查";
                        break;
                    case "09":
                        item.Plan.CHECK_KIND_PRO = "02:省级专项监督抽查";
                        break;
                    case "10":
                        item.Plan.CHECK_KIND_PRO = "03:省级联动监督抽查";
                        break;
                    case "11":
                        item.Plan.CHECK_KIND_PRO = "04:省级产品质量风险监测";
                        break;
                    case "12":
                        item.Plan.CHECK_KIND_PRO = "10:市级监督抽查";
                        break;
                    case "13":
                        item.Plan.CHECK_KIND_PRO = "11:市级专项监督抽查";
                        break;
                    case "14":
                        item.Plan.CHECK_KIND_PRO = "12:市级联动监督抽查";
                        break;
                    case "15":
                        item.Plan.CHECK_KIND_PRO = "13:市级产品质量风险监测";
                        break;
                    default:
                        break;
                }
                switch (item.Plan.CHECK_KIND_ECO)
                {
                    case "1":
                        item.Plan.CHECK_KIND_ECO = "省级监督抽查";
                        break;
                    case "2":
                        item.Plan.CHECK_KIND_ECO = "产品质量风险监测";
                        break;
                    case "3":
                        item.Plan.CHECK_KIND_ECO = "省级联动监督抽查";
                        break;
                    case "4":
                        item.Plan.CHECK_KIND_ECO = "省级专项监督抽查";
                        break;
                    case "5":
                        item.Plan.CHECK_KIND_ECO = "国家联动监督抽查";
                        break;
                    case "6":
                        item.Plan.CHECK_KIND_ECO = "省级监督抽查（产品质量风险监测）";
                        break;
                    case "7":
                        item.Plan.CHECK_KIND_ECO = "联动监督抽查和其他";
                        break;
                    case "08":
                        item.Plan.CHECK_KIND_ECO = "01:定期监督抽查";
                        break;
                    case "09":
                        item.Plan.CHECK_KIND_ECO = "02:省级专项监督抽查";
                        break;
                    case "10":
                        item.Plan.CHECK_KIND_ECO = "03:省级联动监督抽查";
                        break;
                    default:
                        break;
                }
                switch (item.Plan.CHECK_KIND_STORE)
                {
                    case "1":
                        item.Plan.CHECK_KIND_STORE = "省级监督抽查";
                        break;
                    case "2":
                        item.Plan.CHECK_KIND_STORE = "产品质量风险监测";
                        break;
                    case "3":
                        item.Plan.CHECK_KIND_STORE = "省级联动监督抽查";
                        break;
                    case "4":
                        item.Plan.CHECK_KIND_STORE = "省级专项监督抽查";
                        break;
                    case "5":
                        item.Plan.CHECK_KIND_STORE = "国家联动监督抽查";
                        break;
                    case "6":
                        item.Plan.CHECK_KIND_STORE = "省级监督抽查（产品质量风险监测）";
                        break;
                    case "7":
                        item.Plan.CHECK_KIND_STORE = "联动监督抽查和其他";
                        break;
                    case "08":
                        item.Plan.CHECK_KIND_STORE = "01:定期监督抽查";
                        break;
                    case "09":
                        item.Plan.CHECK_KIND_STORE = "02:省级专项监督抽查";
                        break;
                    case "10":
                        item.Plan.CHECK_KIND_STORE = "03:省级联动监督抽查";
                        break;
                    default:
                        break;
                }
                switch (item.Plan.TYPE)
                {
                    case "1 ":
                        item.Plan.TYPE = "抽查并检验";
                        break;
                    case "2 ":
                        item.Plan.TYPE = "抽查";
                        break;
                    case "3 ":
                        item.Plan.TYPE = "检验";
                        break;
                    default: break;
                }
                switch (item.Plan.PLAN_INFO_SYN_TYPE)
                {
                    case "01":
                        item.Plan.PLAN_INFO_SYN_TYPE = "工业品";
                        break;
                    case "02":
                        item.Plan.PLAN_INFO_SYN_TYPE = "消费品";
                        break;
                    default: break;
                }
            }
            switch (item.GOODS_SALE_MODE)
            {
                case "1":
                    item.GOODS_SALE_MODE = "实体店";
                    break;
                case "2":
                    item.GOODS_SALE_MODE = "电商平台";
                    break;
                case "3":
                    item.GOODS_SALE_MODE = "其他";
                    break;
                default: break;
            }
            switch (item.GOODS_CHECK_LEVEL)
            {
                case "1":
                    item.GOODS_CHECK_LEVEL = "工业产品生产许可证";
                    break;
                case "3":
                    item.GOODS_CHECK_LEVEL = "CCC";
                    break;
                case "4":
                    item.GOODS_CHECK_LEVEL = "其他";
                    break;
                case "5":
                    item.GOODS_CHECK_LEVEL = "强制性产品认证";
                    break;
                case "6":
                    item.GOODS_CHECK_LEVEL = "特种设备制造许可";
                    break;
                default: break;
            }
            if (item.ProduceUnit != null)
            {
                switch (item.ProduceUnit.ECO_INSIDE)
                {
                    case "1":
                        item.ProduceUnit.ECO_INSIDE = "国有";
                        break;
                    case "2":
                        item.ProduceUnit.ECO_INSIDE = "集体";
                        break;
                    case "3":
                        item.ProduceUnit.ECO_INSIDE = "股份合作";
                        break;
                    case "4":
                        item.ProduceUnit.ECO_INSIDE = "联营";
                        break;
                    case "5":
                        item.ProduceUnit.ECO_INSIDE = "有限责任公司";
                        break;
                    case "6":
                        item.ProduceUnit.ECO_INSIDE = "股份有限公司";
                        break;
                    case "7":
                        item.ProduceUnit.ECO_INSIDE = "私营";
                        break;
                    case "8":
                        item.ProduceUnit.ECO_INSIDE = "其他企业";
                        break;
                    default: break;
                }
            }

            switch (item.CHECK_TYPE)
            {
                case "1":
                    rtns = item.DataFillingNormal(conn);
                    break;
                case "2":
                    rtns = item.DataFillingMarket(conn);
                    break;
                case "3":
                    rtns = item.DataFillingCommerce(conn);
                    break;
                case "4":
                    rtns = item.DataFillingOther(conn);
                    break;
                default:
                    break;
            }
            if (connDispose) { conn.Dispose(); }

            return rtns;
        }
        /// <summary>
        /// 现场抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail DataFillingNormal(this PlanDetail item, IDbConnection conn)
        {
            var rtns = new PlanDetail();
            item.Cary = new Cary();
            item.ProduceUnit = new ProduceUnit();
            item.ExecUint = new ExecUint();
            item.Other= new Other();
            item.EcPlatform = new EcPlatform();
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }
            rtns.PopulateWith(item);
            return rtns;
        }
        /// <summary>
        /// 市场买样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail DataFillingMarket(this PlanDetail item, IDbConnection conn)
        {
            var rtns = new PlanDetail();
            item.Cary = new Cary();
            item.ProduceUnit = new ProduceUnit();
            item.ExecUint = new ExecUint();
            item.Other= new Other();
            item.EcPlatform = new EcPlatform();
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }
            rtns.PopulateWith(item);
            return rtns;
        }
        /// <summary>
        /// 电商买样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail DataFillingCommerce(this PlanDetail item, IDbConnection conn)
        {
            var rtns = new PlanDetail();
            item.Cary = new Cary();
            item.ProduceUnit = new ProduceUnit();
            item.ExecUint = new ExecUint();
            item.Other= new Other();
            item.EcPlatform = new EcPlatform();
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }

            if (item.EC_ID != null)
            {
                item.EcPlatform = GetEcPlatformById(conn, item.EC_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }
            rtns.PopulateWith(item);
            return rtns;
        }
        /// <summary>
        /// 其他抽样
        /// </summary>
        /// <param name="item"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        internal static PlanDetail DataFillingOther(this PlanDetail item, IDbConnection conn)
        {
            var rtns = new PlanDetail();
            item.Cary = new Cary();
            item.ProduceUnit = new ProduceUnit();
            item.ExecUint = new ExecUint();
            item.Other= new Other();
            item.EcPlatform = new EcPlatform();
            if (item.CARY_ID != null)
            {
                item.Cary = GetCaryById(conn, item.CARY_ID);
            }

            if (item.EXEC_ID != null)
            {
                item.ExecUint = GetExecUintById(conn, item.EXEC_ID);
            }

            if (item.OTHER_ID != null)
            {
                item.Other = GetOtherById(conn, item.OTHER_ID);
            }

            if (item.PRO_ID != null)
            {
                item.ProduceUnit = GetProduceUnitById(conn, item.PRO_ID);
            }
            rtns.PopulateWith(item);
            return rtns;
        }

        /// <summary>
        /// 任务表
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="planCode"></param>
        /// <returns></returns>
        internal static Plan GetPlan(IDbConnection conn, string plancode)
        {
            var rtns = new Plan();
            if (plancode == null) return rtns;

            var query = conn.From<Plan>();
            query.Where(o => o.PLAN_CODE == plancode);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new Plan();
            return rtns;
        }
        /// <summary>
        /// 受检单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="caryId"></param>
        /// <returns></returns>
        internal static Cary GetCaryById(IDbConnection conn, int? caryId)
        {
            var rtns = new Cary();
            if (caryId == null) return rtns;

            var query = conn.From<Cary>();
            query.Where(o => o.ID == caryId);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new Cary();
            return rtns;
        }
        /// <summary>
        /// 生产单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="proId"></param>
        /// <returns></returns>
        internal static ProduceUnit GetProduceUnitById(IDbConnection conn, int? proId)
        {
            var rtns = new ProduceUnit();
            if (proId == null) return rtns;

            var query = conn.From<ProduceUnit>();
            query.Where(o => o.ID == proId);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new ProduceUnit();
            return rtns;
        }
        /// <summary>
        /// 抽样机构信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="execId"></param>
        /// <returns></returns>
        internal static ExecUint GetExecUintById(IDbConnection conn, int? execId)
        {
            var rtns = new ExecUint();
            if (execId == null) return rtns;

            var query = conn.From<ExecUint>();
            query.Where(o => o.ID == execId);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new ExecUint();
            return rtns;
        }
        /// <summary>
        /// 电商单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="ecId"></param>
        /// <returns></returns>
        internal static EcPlatform GetEcPlatformById(IDbConnection conn, int? ecId)
        {
            var rtns = new EcPlatform();
            if (ecId == null) return rtns;

            var query = conn.From<EcPlatform>();
            query.Where(o => o.EC_ID == ecId);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new EcPlatform();
            return rtns;
        }
        /// <summary>
        /// 其他来源单位信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="otherId"></param>
        /// <returns></returns>
        internal static Other GetOtherById(IDbConnection conn, int? otherId)
        {
            var rtns = new Other();
            if (otherId == null) return rtns;

            var query = conn.From<Other>();
            query.Where(o => o.ID == otherId);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new Other();
            return rtns;
        }
        /// <summary>
        /// 直播平台信息
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="liveId"></param>
        /// <returns></returns>
        internal static Live GetLiveById(IDbConnection conn, int? liveId)
        {
            var rtns = new Live();
            if (liveId == null) return rtns;

            var query = conn.From<Live>();
            query.Where(o => o.LIVE_ID == liveId);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new Live();
            return rtns;
        }
        /// <summary>
        /// 任务来源对照表
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="taskSource"></param>
        /// <returns></returns>
        internal static TaskSource GetTaskSource(IDbConnection conn, string taskSource)
        {
            var rtns = new TaskSource();
            if (taskSource == null) return rtns;

            var query = conn.From<TaskSource>();
            query.Where(o => o.TASK_SOURCE == taskSource);
            rtns = conn.Single(query);
            if (rtns == null) rtns = new TaskSource();
            return rtns;
        }

        /// <summary>
        /// 报告编号等信息
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetSUB(this Report rtns, PlanDetail item)
        {
            if(rtns.Metadata.IsNullOrEmpty())rtns.Metadata = new Dictionary<string, string>();
            rtns.Metadata["SamplingOrderID"] = $"{item.PLAN_CODE}{item.LOT_NUM}"; // 抽样单号
            rtns.TypeName = item.Plan.CHECK_KIND_PRO; // 检验类型
            rtns.Type = item.Plan.QT_CPDL_NAME; // 检验分类
            rtns.SampleSourceBatchNumber = item.PLAN_CODE; // 计划编号
            rtns.Metadata["TaskSource"] = item.Plan.TaskSource.PM_CITY; // 任务来源
            rtns.SupplierName = item.Plan.CCJG_NAME; // 检验单位
            rtns.Metadata["SamplingOrgName"] = item.ExecUint.EXEC_NAME; // 抽样单位
            rtns.DemanderName = item.Plan.TaskSource.PM_CITY; // 委托单位
            //rtns.DemanderContactAddress =    // 通讯地址
            //rtns.Category =    // 编码
            return rtns;
        }
        /// <summary>
        /// 受检单位
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetOther(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            rtns.Metadata["InspectedUnitName"] = item.Other.OTHER_NAME; // 受检单位
            rtns.Metadata["InspectedUnitContactName"] = item.Other.OTHER_LINKMAN; // 联系人
            rtns.Metadata["InspectedUnitContactOfficeNumber"] = item.Other.OTHER_TEL; // 联系电话
            //rtns.Metadata["InspectedUnitZipCode"] =  // 邮编
            rtns.Metadata["InspectedUnitAddress"] = item.Other.OTHER_ADDR; // 通讯地址
            rtns.Metadata["InspectedUnitLegalPerson"] = item.Other.OTHER_PRESENT; // 法人代表
            rtns.Metadata["InspectedUnitLicense"] = item.Other.OTHER_UNIFIED_SOCIAL_CREDIT; // 营业执照
            return rtns;
        }
        /// <summary>
        /// 销售单位信息 （现场抽样）
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetCary(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            rtns.Metadata["SalesUnitName"] = item.Cary.CARY_NAME; // 销售单位
            rtns.Metadata["SalesUnitContactName"] = item.Cary.CARY_LINKMAN; // 联系人
            rtns.Metadata["SalesUnitContactOfficeNumber"] = item.Cary.CARY_TEL; // 联系电话
            //rtns.Metadata["SalesUnitZipCode"] = // 邮编
            rtns.Metadata["SalesUnitAddress"] = item.Cary.CARY_ADDR; // 通讯地址
            rtns.Metadata["SalesUnitLegalPerson"] = item.Cary.CARY_PRESENT; // 法人代表
            rtns.Metadata["SalesUnitLicense"] = item.Cary.UNIFIED_SOCIAL_CREDIT_CODE; // 营业执照
            //rtns.Metadata["SalesUnitSoure"] =  // 样品来源
            //rtns.Metadata["SalesUnitLocationCode"] =  // 所属地代码
            rtns.Metadata["SalesUnitLocation"] = item.Cary.CARY_OWNERSHIP; // 所属地
            return rtns;
        }
        /// <summary>
        /// 销售单位信息 （电商买样）
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetEc(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            rtns.Metadata["SalesUnitName"] = item.EcPlatform.ONLINE_STORE_NAME; // 销售单位
            //rtns.Metadata["SalesUnitContactName"] = // 联系人
            //rtns.Metadata["SalesUnitContactOfficeNumber"] =  // 联系电话
            rtns.Metadata["SalesUnitAddress"] = item.EcPlatform.ONLINE_STORE_ADDR; // 通讯地址
            //rtns.Metadata["SalesUnitLegalPerson"] =  // 法人代表
            rtns.Metadata["SalesUnitLicense"] = item.EcPlatform.ONLINE_STORE_POLL_CODE; // 营业执照
            //rtns.Metadata["SalesUnitSoure"] =  // 样品来源
            //rtns.Metadata["SalesUnitLocationCode"] =  // 所属地代码
            rtns.Metadata["SalesUnitLocation"] = item.EcPlatform.ONLINE_OWNERSHIP; // 所属地
            return rtns;
        }
        /// <summary>
        /// 生产单位
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetPro(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            rtns.SampleManufacturerName = item.ProduceUnit.PRO_NAME; // 生产单位
            rtns.SampleManufacturerContactName = item.ProduceUnit.PRO_LINKMAN;  // 联系人
            rtns.SampleManufacturerContactNumber = item.ProduceUnit.PRO_PHONE; // 手机号码
            rtns.Metadata["SampleManufacturerContactOfficePhone"] = item.ProduceUnit.PRO_TEL; // 固定电话
            rtns.SampleManufacturerAddress = item.ProduceUnit.PRO_ADDR; // 通讯地址
            rtns.Metadata["SampleManufacturerLegalPerson"] = item.ProduceUnit.PRO_PRESENT;  // 法人代表
            rtns.Metadata["SampleManufacturerLicense"] = item.ProduceUnit.PRO_BUS_LICENCE;  // 营业执照
            rtns.Metadata["SampleManufacturerPostcode"] = item.ProduceUnit.PRO_ZIP_CODE;  // 邮编
            rtns.Metadata["SampleManufacturerEconomicType"] = item.ProduceUnit.ECO_INSIDE;  // 经济类型
            rtns.Metadata["SampleManufacturerScale"] = item.ProduceUnit.PRO_SACLE_TYPE;  // 企业规模
            rtns.Metadata["SampleManufacturerLocation"] = item.ProduceUnit.PRO_OWNERSHIP;  // 地区
            //rtns.Metadata["SampleManufacturerLocationCode"] =   // 地区代码
            //rtns.Metadata["EntrustedEnterprise"] =   // 委托企业
            //rtns.Metadata["SampleManufacturerEconomicTypeCode"] =   // 代码
            rtns.Metadata["SampleManufacturerScaleCode"] = item.ProduceUnit.PRO_SACLE_TYPE;  // 规模代码
            //rtns.Metadata["SampleManufacturerIsCertified"] =   // 认证情况
            //rtns.Metadata["SampleManufacturerCertificateCode"] =   // 证书编码
            //rtns.Metadata["ReturnMethod"] =   // 退样方式
            rtns.Metadata["SalesRegion"] = item.GOODS_SALE_AREA;  // 销售地区
            rtns.Metadata["SalesMethod"] = item.GOODS_SALE_MODE;  // 销售方式
            rtns.Metadata["PreSales"] = item.LAST_YEAR_SALE;  // 上年销售额
            rtns.Metadata["Protection"] = item.GOODS_PROTECTION_REQ;  // 防护保存
            rtns.Metadata["IsExport"] = item.GOODS_EXPORT;  // 是否出口
            rtns.Metadata["IsReturn"] = item.GOODS_NEEDS_RETREAT;  // 是否退样
            bool.TryParse(item.GOODS_CAN_SALE, out var IsQualifiedAndPending);
            rtns.Metadata["IsQualifiedAndPending"] = IsQualifiedAndPending?"true":"false";  // 合格待销
            rtns.Metadata["IsCommissionProcess"] = item.GOODS_MAN_CONSIGNMENT;  // 委托加工
            return rtns;
        }
        /// <summary>
        /// 产品分类信息
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetGoods(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            //rtns.Metadata["SampleCategory"] =  // 产品分类
            //rtns.Metadata["SampleType"] =  // 产品种类
            //rtns.SampleSerialNumber =  // 产品代码
            rtns.Metadata["RegularCategory"] = item.GOODS_CHECK_LEVEL; // 监管类别
            //rtns.Metadata["RCCode"] =  // 类别代码
            rtns.SampleName = item.GOODS_NAME; // 产品名称
            rtns.SampleModel = item.GOODS_SCALE; // 规格型号
            rtns.SampleBatchNumber = item.GOODS_PRO_LOT; // 批号/货号/款号
            //rtns.SampleGrade = item.GOODS_LEVEL; // 产品等级
            //rtns.SampleGradeSafety = item.GOODS_LEVEL; // 安全类别 
            rtns.SampleBrand = item.GOODS_BRAND; // 商标
            rtns.Metadata["ProductDate"] = item.GOODS_PRO_TIME; // 生产日期
            //rtns.Metadata["SamplingWay"] =  // 抽样方式
            rtns.SampleQuantityUnit = item.GOODS_CHECK_NUM; // 抽样数量
            rtns.Metadata["SamplePreNumber"] = item.GOODS_COPY_NUM; // 备样量
            rtns.Metadata["PackagePlace"] = item.GOODS_COPY_LOCAL; // 封存地点
            rtns.Metadata["SamplingDate"] = item.GOODS_CHECK_TIME; // 抽样日期
            //rtns.Metadata["SamplingMember"] =  // 抽样人员
            rtns.Metadata["SamplingBase"] = item.GOODS_BASE_NUM; // 抽样基数
            rtns.Metadata["SamplingSize"] = item.GOODS_CHECK_LOT; // 抽样批量
            rtns.Metadata["SamplingLocation"] = item.GOODS_CHECK_LOCAL; // 抽样地点
            //rtns.Metadata["SampleEffectiveDate"] =  // 到样日期
            //rtns.Metadata["CheckMemberName"] =  // 检查封样人员
            //rtns.Metadata["SampleCondition"] =  // 样品状态
            rtns.Metadata["PackageStatus"] = item.GOODS_SEAL_STATE; // 封样状态
            //rtns.Metadata["ProductAcceptStatus"] =  // 样品接收状态
            //rtns.Metadata["PurchaseAmount"] = item.PRO_JH_KC; // 进货量
            //rtns.Metadata["InventoryAmount"] = item.PRO_JH_KC; // 存货量 
            //rtns.Metadata["SalesAmount"] =  // 销售量
            rtns.Metadata["SalesPrice"] = item.SALE_PRICE; // 销售价
            //rtns.Metadata["TechParameter"] =  // 工艺参数
            return rtns;
        }
        /// <summary>
        /// 采样信息
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetSampling(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            rtns.Metadata["InvoiceNo"] = item.INVOICE_CODE;  // 发票号
            rtns.Metadata["BillingCompany"] = item.INVOICE_UNIT;  // 开票单位
            //rtns.Metadata["ShopLicense"] =  // 直播 ID 号
            //rtns.Metadata["MarketingName"] =  // 直播昵称
            rtns.Metadata["SamplingPlatform"] = item.EcPlatform.EC_PLATFORM_NAME; // 所属平台
            //rtns.Metadata["PlatformAddress"] =  // 平台地址
            rtns.Metadata["PlatformLocation"] = item.EcPlatform.EC_PLATFORM_OWNERSHIP; // 平台所属地
            //rtns.Metadata["PlatformLocationCode"] =  // 平台地区代码
            //rtns.Metadata["OtherContact"] =  // 联系方式
            rtns.Metadata["SamplingLink"] = item.LINKS_WEB_SITES; // 链接地址
            rtns.Metadata["EcommerceLocation"] = item.EcPlatform.ONLINE_OWNERSHIP; // 店铺所属地
            //rtns.Metadata["EcommerceLocationCode"] =  // 店铺地区代码
            //rtns.Metadata["GoodsBarcodeId"] =  // 商品条码
            //rtns.Metadata["VideoNumber"] =  // 抽样视频单号
            //rtns.Metadata["EmployedNumber"] =  // 从业人员数
            //rtns.Metadata["OperatingRevenue"] =  // 营业收入
            return rtns;
        }
        /// <summary>
        /// 检验、受理人、备注信息
        /// </summary>
        /// <param name="item"></param>
        /// <returns></returns>
        internal static Report ConvertGetRemarks(this Report rtns, PlanDetail item)
        {
            if (rtns.Metadata.IsNullOrEmpty()) rtns.Metadata = new Dictionary<string, string>();
            rtns.TestStandards = item.GOODS_STANDARD; // 检验/判定依据
            //rtns.Metadata["JudgeOverView"] =  // 判定依据 (国抽)
            //rtns.TestDetections =  // 检验项目
            //rtns.OperatorName =  // 受理人
            //rtns.AmountTestPlan =  // 检验费
            //rtns.AmountTest =  // 折后费
            //rtns.Quantity =  // 报告份数
            //rtns.TemplateName =  // 报告格式
            //rtns.Metadata["TestDate"] =  // 检验日期
            //rtns.DeadDate =  // 报告日期
            //rtns.Metadata["ResultIsPost"] =  // 结果通知书是否寄存
            //rtns.Metadata["TestResultIsConfirm"] =  // 检验结果是否确认
            rtns.Remark = item.REMARKS; // 首页备注
            //rtns.Metadata["RemarkEx"] =  // 附页备注
            return rtns;
        }

    }
}
